<?php

//      
function parse_query_string($query_string)
{
  //       -
  $items = explode('&', $query_string);

  //   
  $qs_array = array();

  //  
  foreach($items as $i)
  {
    //   -      $qs_array
    $pair = explode('=', $i);
    $qs_array[urldecode($pair[0])] = urldecode($pair[1]); 
  }

  //  
  return $qs_array;
}

//     
function remove_query_param($url, $param)
{
  //     $url
  $tokens = explode('?', $url);
  $url_path = $tokens[0];  
  $query_string = $tokens[1];

  //      
  $qs_array = parse_query_string($query_string);

  //   $param  
  unset($qs_array[$param]);

  //       
  $new_query_string = '';
  if ($qs_array) 
  {
    foreach ($qs_array as $name => $value)
    {
      $new_query_string .= ($new_query_string == '' ? '? ' : '&') 
                           . urlencode($name) . '=' . urlencode($value);
    }
  }

  //  URL,   $param  
  return $url_path . $new_query_string;
}

?>
