<?php

/*
// +----------------------------------------------------------------------+
// | SimpleCloak                                                          |
// |                                          |
// | http://www.SEOEgghead.com                                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2005-2006                   |
// +----------------------------------------------------------------------+
*/

//   
require_once('config.inc.php');

class SimpleCloak
{
  //   
  function isSpider($spider_name = '', $check_uas = true, $check_ips = true)
  {
    //      0
    $confidence = 0;

    //   ?
    if ($check_uas)
      if (SimpleCloak::_get(0, $spider_name, 'UA', $_SERVER['HTTP_USER_AGENT']))
        $confidence += 2;

    //  IP?
    if ($check_ips)
      if (SimpleCloak::_get(0, $spider_name, 'IP', '', $_SERVER['REMOTE_ADDR']))
        $confidence += 3;

    //   
    return $confidence;
  }

  //   ,     
  function _get($id = 0, $spider_name = '', $record_type = '',
               $value = '', $wildcard_value = '')
  {
    //     
    $q = " SELECT cloak_data.* FROM cloak_data WHERE TRUE ";

    //  
    if ($id) {
      $id = (int) $id;
      $q .= " AND id = $id ";
    }
    if ($spider_name) {
      $spider_name = mysql_escape_string($spider_name);
      $q .= " AND spider_name = '$spider_name' ";
    }
    if ($record_type) {
      $record_type = mysql_escape_string($record_type);
      $q .= " AND record_type = '$record_type' ";
    }
    if ($value) {
      $value = mysql_escape_string($value);
      $q .= " AND value = '$value' ";
    }
    if ($wildcard_value) {
      $wildcard_value = mysql_escape_string($wildcard_value);
      $q .= " AND '$wildcard_value' LIKE CONCAT(value, '%') ";
    }

    //    MySQL
    $dbLink = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD)
                    or die("  : " . mysql_error());

    //     seophp
    mysql_select_db(DB_DATABASE) or die("    ");

    //  
    $tmp = mysql_query($q);

    //     
    mysql_close($dbLink);

    //     
    $rows = array();
    while ($_x = mysql_fetch_assoc($tmp)) {
      $rows[] = $_x;
    }
    return $rows;
  }

  //        ,   
  //    7       iplists.org
  function updateAll()
  {
    //    MySQL
    $dbLink = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD)
                    or die("  : " . mysql_error());

    //     seophp 
    mysql_select_db(DB_DATABASE) or die("    ");

    //       
    $q = "SELECT cloak_update.* FROM cloak_update";
    $tmp = mysql_query($q);
    $updated = mysql_fetch_assoc($tmp);
    $db_version = $updated['version'];
    $updated_on = $updated ['updated_on'];

    //     7 ,     
    if (isset($updated_on) &&
        (strtotime($updated_on) > strtotime("-604800 seconds"))) 
    {
      //     
      mysql_close($dbLink);
      //  false, ,     
      return false;
    }

    //    iplists
    $version_url = 'http://www.iplists.com/nw/version.php';
    $latest_version = mysql_escape_string(file_get_contents($version_url));

    //          
    if (!$latest_version)
    {
      //  false, ,     
      return false;
    }

    //   
    $q = "DELETE FROM cloak_update";
    mysql_query($q);
    $q = "INSERT INTO cloak_update (version, updated_on) " .
         "VALUES('$latest_version', NOW())";
    mysql_query($q);

    //     ,   
    if ($latest_version == $db_version) 
    {
      //      
      mysql_close($dbLink);
      //  false, ,     
      return false;
    }

    //   
    SimpleCloak::_updateCloakingDB('google',
                                  'http://www.iplists.com/nw/google.txt');
    SimpleCloak::_updateCloakingDB('yahoo',
                                  'http://www.iplists.com/nw/inktomi.txt');
    SimpleCloak::_updateCloakingDB('msn',
                                  'http://www.iplists.com/nw/msn.txt');
    SimpleCloak::_updateCloakingDB('ask', 
                                  'http://www.iplists.com/nw/askjeeves.txt');
    SimpleCloak::_updateCloakingDB('altavista',
                                  'http://www.iplists.com/nw/altavista.txt');
    SimpleCloak::_updateCloakingDB('lycos',
                                  'http://www.iplists.com/nw/lycos.txt');
    SimpleCloak::_updateCloakingDB('wisenut',
                                  'http://www.iplists.com/nw/wisenut.txt');

    //  
    mysql_close($dbLink);

    //  true,   
    return true;
  }

  //   URL        
  function _updateCloakingDB($spider_name, $url,
      $ua_regex = '/^# UA "(.*)"$/m', $ip_regex = '/^([0-9.]+)$/m')
  {
    //  cURL     $url
    // :    web      
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_HEADER, 1);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
    $result = curl_exec($ch);
    curl_close($ch);

    //   IP      _parseListURL 
    $lists = SimpleCloak::_parseListURL($result, $ua_regex, $ip_regex);

    //    IP-  ,   
    if (!$lists['ua_list'] || !$lists['ip_list']) return;

    //   cloack_data,     
    mysql_query('LOCK TABLES cloak_data WRITE');

    //      $spider_name
    SimpleCloak::_deleteSpiderData($spider_name);

    //      
    foreach ($lists['ua_list'] as $ua) {
      SimpleCloak::_insertSpiderData($spider_name, 'UA', $ua);
    }

    //   IP  
    foreach ($lists['ip_list'] as $ip) {
      SimpleCloak::_insertSpiderData($spider_name, 'IP', $ip);
    }

    //   
    mysql_query('UNLOCK TABLES');
  }

  //         IP
  function _parseListURL($data, $ua_regex, $ip_regex)
  {
    $ua_list_ret = preg_match_all($ua_regex, $data, $ua_list);
    $ip_list_ret = preg_match_all($ip_regex, $data, $ip_list);
    return array('ua_list' => $ua_list[1], 'ip_list' => $ip_list[1]);
  }

  //       
  function _insertSpiderData($spider_name, $record_type, $value)
  {
    //   
    $spider_name = mysql_escape_string($spider_name);
    $record_type = mysql_escape_string($record_type);
    $value = mysql_escape_string($value);

    //     INSERT
    $q  = "INSERT INTO cloak_data (spider_name, record_type, value) " .
          "VALUES ('$spider_name', '$record_type', '$value')";
    mysql_query($q);
  }

  //      
  function _deleteSpiderData($spider_name)
  {
    //   
    $spider_name = mysql_escape_string($spider_name);

    //     DELETE
    $q = "DELETE FROM cloak_data WHERE spider_name='$spider_name'";
    mysql_query($q);
  }
}
?>