<?php
//   
require_once 'include/catalog.inc.php';
//    URL 
require_once 'include/url_factory.inc.php';
//    URL
require_once 'include/url_redirect.inc.php';
//   
require_once 'include/simple_pager.inc.php';

//    
$category_id = $_GET['category_id'];
$categories = Categories::get($category_id);
$category = $categories[0];
$category_name = $category['name'];

//   ;    1
$page = isset($_GET['page']) ? $_GET['page'] : 1;

//      URL 
$proper_url = make_category_url($category['name'], $category_id, $page);
fix_category_url($proper_url);

//    
$products = Products::get(0, $category_id);

//   404   
if  (!$products) {
  header("HTTP/1.0 404 Not Found");
  exit();
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
  <head>
    <title><?php echo $category_name ?> -   </title>
  </head>
  <body>
    <h1>
      <?php echo $category_name ?> -
      <a href="/">  </a>
    </h1>
          
    <b><?php echo $category_name ?></b>:

<?php
//   URL
require_once 'include/url_factory.inc.php';

//   
echo "<ul>";

//  ,    
$start = ($page - 1) * PRODUCTS_PER_PAGE;
$end = min ($start + PRODUCTS_PER_PAGE, count($products));

//     
for ($i = $start; $i < $end; $i++ )
{
  $url = make_category_product_url($category_name, $category_id,
                                   $products[$i]['name'], $products[$i]['id']);
  echo '<li>' .
       '<a href="' . $url . '"' . '>' . $products[$i]['name'] . '</a>' .
       '</li>';
}
echo "</ul>";

//      SimplePager
$simple_pager = new SimplePager($products, PRODUCTS_PER_PAGE, 'make_category_url');
echo $simple_pager->display($page, $products, array($category_name, $category_id));
?>

  </body>
</html>