<?php
//   
require_once 'include/catalog.inc.php';
//   URL
require_once 'include/url_factory.inc.php';
//   SimpleGeoTarget
require_once 'include/simple_geo_target.inc.php';
//    URL
require_once 'include/url_redirect.inc.php';

//    
$product_id = $_GET['product_id'];
$products = Products::get($product_id);
$product = $products[0];

//          
$category_id = $_GET['category_id'];
$categories = Categories::get($category_id);
$category = $categories[0];
$category_url = make_category_url($category['name'], $category['id']);

//      URL
$proper_url = make_category_product_url($category['name'], $category_id,
                                        $product['name'], $product_id);
fix_category_product_url($proper_url);

//    
$brand_id = $product['brand_id'];
$brands = Brands::get($brand_id);
$brand = $brands[0];
$brand_image_url = make_media_url($brand_id, $brand['name'], 'jpg');

//   404     
if  (!$product || !$category) {
  header("HTTP/1.0 404 Not Found");
  exit();
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
  <head>
    <title><?php echo $product['name'] ?> -   </title>
  </head>
  <body>
    <!--        -->
    <h1>
      <?php echo $product['name'] ?> -
      <a href="/">  </a>
    </h1>

    <!   -->
    <p><?php echo $product['desc'];?></p>

    <!   -->
    <p>
          <?php echo $brand['name']; ?>.
      <br /><img src="<?php echo $brand_image_url; ?>"/>
    </p>

    <!   -->
    <p>:
<?php
//      ,      
if (SimpleGeoTarget::isRegion("UA"))
  echo $product['price'] * 1.17 . ' ';
else
  echo $product['price'] . ' ';
?>
    </p>

         
    <a href="<?php echo $category_url; ?>">
      <?php echo $category['name']; ?></a>.
  </body>
</html>