<?php

//    URL 
require_once 'url_factory.inc.php';

//    index.php  index.html   
function fix_index_url()
{
  //   index.php   ./
  if (preg_match('#(.*)index\.(html|php)$#', $_SERVER['REQUEST_URI'], $captures))
  {
    //   301   URL
    header('HTTP/1.1 301 Moved Permanently');
    header('Location: ' . $captures[1]);
  }
}

//    URL,    
function fix_category_product_url()
{   
  //   URL    /
  $proper_url = get_proper_category_product_url();

  //    301   URL 
  if (SITE_DOMAIN . $_SERVER['REQUEST_URI'] != $proper_url) 
  { 
    header('HTTP/1.1 301 Moved Permanently');
    header('Location: ' . $proper_url);
    exit();     
  }
}

//   URL   
function get_proper_category_product_url()
{
  //  ID      
  $product_id = $_GET['product_id'];
  $category_id = $_GET['category_id'];

  //         
  $product_name = $GLOBALS['products'][$product_id];
  $category_name = $GLOBALS['categories'][$category_id];

  //  URL   
  $proper_url = make_category_product_url($category_name, $category_id, 
                                          $product_name, $product_id);

  //   URL   ,    
  return $proper_url;
}

?>