<?php

//   
require_once 'config.inc.php';

//     $str      fixLink()
function noFollowLinks($str) 
{ 
  //       fixLink() 
  return preg_replace_callback(
    "#(<a.*?>)#i", 
    create_function('$matches', 'return fixLink($matches[1]);'),
    $str);  
} 

//  ,    <a href="http://too.much.spam/">,
//    ref="nofollow",       
function fixLink($input)
{
  //      
  $whitelist = $GLOBALS['whitelist'];

  //    $input   ref="nofollow",    
  if (preg_match('#rel\s*?=\s*?[\'"]?.*?nofollow.*?[\'"]?#i', $input)) 
  {
    return $input;   
  }

  //  URL  $input
  preg_match('#href\s*?=\s*?[\'"]?([^\'"]*)[\'"]?#i', $input, $captures);

  //  $href   URL,  http://seophp.example.com
  $href = $captures[1];

  //  URL   http://,    
  if (!preg_match('#^\s*http://#', $href))
  {
    return $input;
  }

  //   URL  ,  seophp.example.com
  $parsed = parse_url($href);
  $host = $parsed['host'];

  //  URL    , $input   
  if (in_array($host, $whitelist)) 
  {
    return $input;
  } 

  //   URL    rel,     nofollow
  $x = preg_replace('#(rel\s*=\s*([\'"]?))((?(3)[^\'"]*|[^\'" ]*))([\'"]?)#i', 
                    '\\1\\3,nofollow\\4', $input);

  //   ,       rel,  
  //   nofollow,    
  if ($x != $input) 
  {
    return $x;
  } 
  //         ref attribute,  
  else 
  {
    return preg_replace('#<a#i', '<a rel="nofollow"', $input);
  }
}

?>