<?php

//  HTML-  $inputHTML
function sanitizeHTML(
    $inputHTML, 
    $allowed_tags = array('<h1>', '<b>', '<i>', '<a>', 
                          '<ul>', '<li>', '<pre>', '<hr>', 
                          '<blockquote>', '<img>')) 
{
  $_allowed_tags = implode('', $allowed_tags);
  $inputHTML = strip_tags($inputHTML, $_allowed_tags);
  return preg_replace('#<(.*?)>#ise', "'<' . removeBadAttributes('\\1') . '>'" , $inputHTML);
}

//     $inputHTML
function removeBadAttributes($inputHTML)
{
  //    
  $bad_attributes = 'onerror|onmousemove|onmouseout|onmouseover|' .
                    'onkeypress|onkeydown|onkeyup|javascript:';

  //      
  return stripslashes(preg_replace("#($bad_attributes)(\s*)(?==)#is" , 
                      'SANITIZED', $inputHTML)); 
}

?>