<?php
//   Words 
require_once('Numbers/Words.php');

//  SimpleCAPTCHA
class SimpleCAPTCHA
{
  //  
  function check_answer($answer, $hash) 
  {
    return (md5(trim($answer) . $_SERVER['SERVER_ADDR']) == $hash);
  }
  
  //  
  function get_question($max_1, $max_2)
  {
    //    
    $question_formats = array(
      '  %s  %s?',
      '  %s  %s?', 
      '  %s  %s?',
      '  %s + %s?'
    );

    //   
    $number_1 = rand(0, $max_1);
    $number_2 = rand(0, $max_2);

    //    
    $number_1_words = Numbers_Words::toWords($number_1);
    $number_2_words = Numbers_Words::toWords($number_2);

    //   
    $question = sprintf($question_formats[rand(0, 
                          sizeof($question_formats) - 1)], 
                        $number_1_words, 
                        $number_2_words); 
    
    //     
    return array('question' => $question, 
       'hash' => md5(($number_1 + $number_2) . $_SERVER['SERVER_ADDR']));
  }
  
  //  -
  function display_demo_form()
  {
    $gq = SimpleCAPTCHA::get_question(1000, 10);
    echo '<form>';
    echo $gq['question'];
    echo '<input type="text" name="response">';
    echo '<input type="hidden" name="hash" value="' . $gq['hash'] . '">';
    echo '</form>';
  } 
}

?>